%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

Distribution:   CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>

Summary:	common interface to speech synthesis
Name:		speech-dispatcher
Version:	0.7
Release:	2
License:	GNU/GPL
URL:		http://www.freebsoft.org/speechd
Group:		User Interface/Speech Synthesis
Source0:	%{name}-%{version}.tar.gz
Source1:        http://www.nsitonline.in/hemant/stuff/speechd-rpm/speech-dispatcherd
Patch0:		speech-dispatcher-0.7-python26-patch
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildArch:	i686
Requires(post,preun): /sbin/install-info

BuildRequires:  flite-devel

BuildRequires:	texinfo

#Automatically resolved build dependencies
BuildRequires: alsa-lib-devel
BuildRequires: dotconf-devel
BuildRequires: espeak-devel
BuildRequires: flac-devel
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: libogg-devel
BuildRequires: libsndfile-devel
BuildRequires: libvorbis-devel
BuildRequires: pulseaudio-libs-devel
BuildRequires: python26-devel

%description
The goal of Speech Dispatcher project is to provide a high-level device independent layer for speech synthesis through a simple, stable and well documented interface. 
Key features: 
Common interface to different TTS engines 
Handling concurrent synthesis requests ? requests may come assynchronously from multiple sources within an application and/or from more different applications 
Subsequent serialization, resolution of conflicts and priorities of incomming requests 
Context switching ? state is maintained for each client connection independently, event for connections from within one application 
High-level client interfaces for popular programming languages 
Common sound output handling ? audio playback is handled by Speech Dispatcher rather than the TTS engine, since most engines have limited sound output capabilities 
What is a very high level GUI library to graphics, Speech Dispatcher is to speech synthesis. The application neither needs to talk to the devices directly nor to handle concurrent access, sound output and other tricky aspects of the speech subsystem. 


%package devel
Summary:        %{name} development headers.
Group:          %{group}
Requires:       %{name} = %{version}-%{release}

%description devel
Header and include files for developing applications with %{name}.

%package python
Summary:        %{name} python bindings.
Group:          %{group}
Requires:       %{name} = %{version}-%{release}

%description python
Python bindings for %{name}.


%post
/sbin/install-info %_infodir/%{name}.info.gz %_infodir/dir
/sbin/install-info %_infodir/spd-say.info.gz %_infodir/dir
/sbin/install-info %_infodir/%{name}-cs.info.gz %_infodir/dir
/sbin/install-info %_infodir/ssip.info.gz %_infodir/dir
ldconfig

%postun
ldconfig

%preun
if [ "$1" = 0 ]; then
/sbin/install-info --del %_infodir/%{name}.info.gz %_infodir/dir
/sbin/install-info --del %_infodir/spd-say.info.gz %_infodir/dir
/sbin/install-info --del %_infodir/%{name}-cs.info.gz %_infodir/dir
/sbin/install-info --del %_infodir/ssip.info.gz %_infodir/dir
fi

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

%build
./build.sh
iconv -f ISO-8859-2 -t UTF-8 doc/speech-dispatcher-cs.texi -o doc/speech-dispatcher-cs_c.texi
mv doc/speech-dispatcher-cs_c.texi doc/speech-dispatcher-cs.texi

%configure --disable-static --with-alsa --with-pulse --without-flite --sysconfdir=%{_sysconfdir}

# Remove rpath as per https://fedoraproject.org/wiki/Packaging/Guidelines#Beware_of_Rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

#Install the Python Modules
cd src/python/
mkdir -p build/lib/speechd
python2.6 setup.py install --root $RPM_BUILD_ROOT

#chmod 0755 $RPM_BUILD_ROOT%{python_sitelib}/speechd/_test.py

#Move to the base BUILD folder
cd ../../

for dir in \
 config/ doc/ src/audio/ src/c/ src/modules/ src/tests/ src/server/
 do
  pushd $dir
  make install DESTDIR=$RPM_BUILD_ROOT INSTALL="install -p"
 popd
done

#Install the init shell script
%if 0%{?fedora}
 mkdir -p $RPM_BUILD_ROOT%{_initrddir}
 install -p -m 0755 %SOURCE1 $RPM_BUILD_ROOT%{_initrddir}/
%endif

#Rename certain generically named binaries
mv $RPM_BUILD_ROOT%{_bindir}/long_message $RPM_BUILD_ROOT%{_bindir}/spd_long_message
mv $RPM_BUILD_ROOT%{_bindir}/run_test $RPM_BUILD_ROOT%{_bindir}/spd_run_test

#Remove %{_infodir}/dir file
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

cd ../../
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

# Move the config files from /usr/share to /etc
%{__mkdir} -p $RPM_BUILD_ROOT%{_sysconfdir}/speech-dispatcher/clients
%{__mkdir} -p $RPM_BUILD_ROOT%{_sysconfdir}/speech-dispatcher/modules
mv $RPM_BUILD_ROOT%{_datadir}/speech-dispatcher/conf/speechd.conf $RPM_BUILD_ROOT%{_sysconfdir}/speech-dispatcher/
mv $RPM_BUILD_ROOT%{_datadir}/speech-dispatcher/conf/clients/* $RPM_BUILD_ROOT%{_sysconfdir}/speech-dispatcher/clients
mv $RPM_BUILD_ROOT%{_datadir}/speech-dispatcher/conf/modules/* $RPM_BUILD_ROOT%{_sysconfdir}/speech-dispatcher/modules

# Now move the files, change ownerships, apply setuid settings incase build is for
# olpc.

%if 0%{?olpc}
 #Move the speech-dispatcher configuration files to olpc writable location.
 mkdir -p $RPM_BUILD_ROOT/home/olpc/.speechd
 mv $RPM_BUILD_ROOT%{_sysconfdir}/speech-dispatcher/* $RPM_BUILD_ROOT/home/olpc/.speechd
%endif

# Remove dummy sound
%{__rm} -rf $RPM_BUILD_ROOT/%{_datadir}/sounds/

# Create log dir
%{__mkdir} -p -m 0700 $RPM_BUILD_ROOT%{_localstatedir}/log/speech-dispatcher/

# strip debug symbols from binaries
find $RPM_BUILD_ROOT -type f -exec /usr/bin/strip --strip-debug '{}' ';' 

%files
%defattr(-,root,root)
%{_sysconfdir}/speech-dispatcher/clients/emacs.conf
%{_sysconfdir}/speech-dispatcher/clients/gnome-speech.conf
%{_sysconfdir}/speech-dispatcher/modules/cicero.conf
%{_sysconfdir}/speech-dispatcher/modules/dtk-generic.conf
%{_sysconfdir}/speech-dispatcher/modules/epos-generic.conf
%{_sysconfdir}/speech-dispatcher/modules/espeak.conf
%{_sysconfdir}/speech-dispatcher/modules/espeak-generic.conf
%{_sysconfdir}/speech-dispatcher/modules/espeak-mbrola-generic.conf
%{_sysconfdir}/speech-dispatcher/modules/festival.conf
%{_sysconfdir}/speech-dispatcher/modules/flite.conf
%{_sysconfdir}/speech-dispatcher/modules/ibmtts.conf
%{_sysconfdir}/speech-dispatcher/modules/ivona.conf
%{_sysconfdir}/speech-dispatcher/modules/llia_phon-generic.conf
%{_sysconfdir}/speech-dispatcher/modules/swift-generic.conf
%{_sysconfdir}/speech-dispatcher/speechd.conf
%{_bindir}/clibrary
%{_bindir}/clibrary2
%{_bindir}/connection_recovery
%{_bindir}/spd-conf
%{_bindir}/spd_long_message
%{_bindir}/spd_run_test
%{_bindir}/spd-say
%{_bindir}/spdsend
%{_bindir}/speech-dispatcher
%{_libdir}/libspeechd.so.*
%{_libdir}/speech-dispatcher
%{_libdir}/speech-dispatcher-modules
%{_infodir}/spd-say.info.gz
%{_infodir}/speech-dispatcher-cs.info.gz
%{_infodir}/speech-dispatcher.info.gz
%{_infodir}/ssip.info.gz

%files devel
%defattr(-,root,root)
%{_includedir}/libspeechd.h
%{_libdir}/libspeechd.so

%files python
%defattr(-,root,root)
%{_libdir}/python2.6/site-packages/speechd-0.3-py2.6.egg-info
%{_libdir}/python2.6/site-packages/speechd/client.py
%{_libdir}/python2.6/site-packages/speechd/client.pyc
%{_libdir}/python2.6/site-packages/speechd_config-0.0-py2.6.egg-info
%{_libdir}/python2.6/site-packages/speechd_config/config.py
%{_libdir}/python2.6/site-packages/speechd_config/config.pyc
%{_libdir}/python2.6/site-packages/speechd_config/__init__.py
%{_libdir}/python2.6/site-packages/speechd_config/__init__.pyc
%{_libdir}/python2.6/site-packages/speechd_config/paths.py
%{_libdir}/python2.6/site-packages/speechd_config/paths.pyc
%{_libdir}/python2.6/site-packages/speechd/__init__.py
%{_libdir}/python2.6/site-packages/speechd/__init__.pyc
%{_libdir}/python2.6/site-packages/speechd/_test.py
%{_libdir}/python2.6/site-packages/speechd/_test.pyc
%{_libdir}/python2.6/site-packages/speechd/paths.py
%{_libdir}/python2.6/site-packages/speechd/paths.py
%{_libdir}/python2.6/site-packages/speechd/paths.pyc

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Jul 22 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.7-2
- rebuilt against dotconf 1.3
* Thu Jul 08 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.7-1
- version update
* Thu Feb 11 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.6.7-1
- version update
* Tue Dec 25 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.6.5-1
- Initial Release
